## mingw-w64-qownnotes-25.10.4-1.src.tar.zst

=== libraries/botan/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(Botan)

option(BUILD_WITH_SYSTEM_BOTAN
       "Build using system installed Botan 2 crypto library" OFF)

add_library(botan STATIC "")
add_library(Botan::Botan ALIAS botan)

target_sources(botan PRIVATE botanwrapper.h botanwrapper.cpp)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

target_link_libraries(botan PUBLIC Qt${QT_VERSION_MAJOR}::Core)

target_include_directories(botan PUBLIC ${CMAKE_CURRENT_LIST_DIR})

if(BUILD_WITH_SYSTEM_BOTAN)
  find_package(Botan3 REQUIRED)
  if(NOT TARGET Botan3::Botan3)
    message(FATAL_ERROR "Could not find system Botan 3 library using PkgConfig")
  endif()

  target_link_libraries(botan PUBLIC Botan3::Botan3)

  target_compile_definitions(botan PUBLIC USE_SYSTEM_BOTAN)

  # Instead of put next lines into else() block it is better to just return
  return()
endif()

target_sources(botan PRIVATE botan.h botan.cpp botan_internal.h)

# add some Botan defines for Linux
if(UNIX)
  # Append some definitions as PRIVATE only if they used only in cpp and
  # botan_internal header
  target_compile_definitions(botan PRIVATE BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
endif()
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  target_compile_definitions(
    botan PRIVATE BOTAN_TARGET_OS_HAS_CLOCK_GETTIME
                  BOTAN_TARGET_OS_HAS_POSIX_MLOCK BOTAN_TARGET_OS_HAS_POSIX1)
endif()
if(APPLE)
  target_compile_definitions(botan PRIVATE BOTAN_TARGET_OS_HAS_POSIX1)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_definitions(botan PUBLIC BOTAN_BUILD_COMPILER_IS_GCC)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  target_compile_definitions(botan PUBLIC BOTAN_BUILD_COMPILER_IS_CLANG)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  target_compile_definitions(botan PRIVATE BOTAN_BUILD_COMPILER_IS_INTEL)
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES "(i386|i686|x86_64|AMD64)")
  if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_compile_definitions(botan PUBLIC BOTAN_TARGET_CPU_IS_X86_FAMILY
                                            BOTAN_TARGET_ARCH_IS_X86_32)
  elseif(CMAKE_SIZEOF_VOID_P EQUAL 8)
    target_compile_definitions(
      botan PUBLIC BOTAN_TARGET_CPU_IS_X86_FAMILY BOTAN_TARGET_ARCH_IS_X86_64
                   BOTAN_TARGET_CPU_HAS_NATIVE_64BIT)
  endif()
endif()

if(WIN32)
  target_compile_definitions(
    botan PRIVATE BOTAN_TARGET_OS_IS_WINDOWS BOTAN_TARGET_OS_HAS_WIN32
                  BOTAN_HAS_ENTROPY_SRC_WIN32)
  if(MSVC)
    # TODO Find analog for: QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHs
    target_compile_options(botan PUBLIC "-EHs" "-wd4251" "-wd4290" "-wd4250")
    target_compile_definitions(botan PRIVATE _SCL_SECURE_NO_WARNINGS
                                             _CRT_SECURE_NO_WARNINGS)
    target_compile_definitions(botan PUBLIC BOTAN_BUILD_COMPILER_IS_MSVC)
    if(NOT (MSVC_VERSION LESS 1900))
      # For included library binary ABI does not matter so disable warning
      target_compile_definitions(botan PRIVATE _ENABLE_EXTENDED_ALIGNED_STORAGE)
    endif()
  else()
    target_compile_options(botan PRIVATE "-fpermissive" "-finline-functions"
                                         "-Wno-long-long")
  endif()
endif()

if(UNIX AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set_target_properties(botan PROPERTIES POSITION_INDEPENDENT_CODE ON)
  target_compile_options(botan PRIVATE "-fpermissive" "-finline-functions"
                                       "-Wno-long-long")
endif()

if(CMAKE_SYSTEM_NAME MATCHES "(Linux|FreeBSD)")
  target_link_libraries(botan PRIVATE rt)
  target_compile_definitions(botan PRIVATE BOTAN_TARGET_OS_HAS_GETAUXVAL)
endif()

=== libraries/diff_match_patch/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(DiffMatchPatchLib)

add_library(diff_match_patch STATIC diff_match_patch.h diff_match_patch.cpp)

add_library(Google::DiffMatchPatch ALIAS diff_match_patch)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

target_include_directories(diff_match_patch PUBLIC ${CMAKE_CURRENT_LIST_DIR})

target_link_libraries(diff_match_patch PUBLIC Qt${QT_VERSION_MAJOR}::Core)

=== libraries/fakevim/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(fakevim VERSION 0.0.1)

# Library name
set(bin fakevim)

# Public headers
set(${bin}_public_headers fakevim/fakevimactions.h fakevim/fakevimhandler.h)

# Source files common for all platforms
set(${bin}_sources
    fakevim/fakevimactions.cpp fakevim/fakevimhandler.cpp
    fakevim/utils/hostosinfo.cpp fakevim/utils/osspecificaspects.h
    fakevim/utils/qtcassert.cpp ${${bin}_public_headers})

# Required pkg-config packages
set(${bin}_pkg_config_requires)

include(cmake/cxx17.cmake)
include(cmake/library.cmake)
include(cmake/qt.cmake)
include(cmake/pkg-config.cmake)

# Files with Q_OBJECT macros to pass to moc utility
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(QT_VERSION_MAJOR EQUAL 6)
  qt6_wrap_cpp(${bin}_mocced "fakevim/fakevimhandler.h")
else()
  qt5_wrap_cpp(${bin}_mocced "fakevim/fakevimhandler.h")
endif()
target_sources(${bin} PRIVATE ${${bin}_mocced})

target_compile_definitions(
  ${bin} PRIVATE QT_NO_CAST_TO_ASCII QT_RESTRICTED_CAST_FROM_ASCII
                 QTCREATOR_UTILS_STATIC_LIB)

option(BUILD_TESTS "Build tests")
if(BUILD_TESTS)
  message(STATUS "Building tests")

  find_package(Qt5Test REQUIRED)

  add_executable(fakevim_test tests/fakevim_test.cpp tests/fakevimplugin.h
                              example/editor.cpp)
  set_property(TARGET fakevim_test PROPERTY AUTOMOC ON)
  target_link_libraries(fakevim_test fakevim Qt5::Widgets Qt5::Test)

  target_include_directories(fakevim_test PRIVATE ${CMAKE_SOURCE_DIR}/fakevim
                                                  ${CMAKE_SOURCE_DIR})

  add_test(fakevim_test fakevim_test)
  enable_testing()
endif()

option(BUILD_EXAMPLE "Build example")
if(BUILD_EXAMPLE)
  message(STATUS "Building example")

  add_executable(fakevim_example example/main.cpp example/editor.cpp)
  set_property(TARGET fakevim_example PROPERTY AUTOMOC ON)

  target_link_libraries(fakevim_example fakevim)
  target_link_libraries(fakevim_example Qt5::Widgets)
endif()

=== libraries/qhotkey/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(qhotkey VERSION 1.5.0 LANGUAGES CXX)

option(QHOTKEY_EXAMPLES "Build examples" OFF)
option(QHOTKEY_INSTALL "Enable install rule" ON)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)

if(NOT QT_DEFAULT_MAJOR_VERSION)
    set(QT_DEFAULT_MAJOR_VERSION 5 CACHE STRING "Qt version to use (5 or 6), defaults to 5")
endif()

if(QT_DEFAULT_MAJOR_VERSION EQUAL 6)
    find_package(Qt${QT_DEFAULT_MAJOR_VERSION} 6.2.0 COMPONENTS Core Gui REQUIRED)
else()
    find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS Core Gui REQUIRED)
endif()

add_library(qhotkey QHotkey/qhotkey.cpp)
add_library(QHotkey::QHotkey ALIAS qhotkey)
target_link_libraries(qhotkey PUBLIC Qt${QT_DEFAULT_MAJOR_VERSION}::Core Qt${QT_DEFAULT_MAJOR_VERSION}::Gui)

if(BUILD_SHARED_LIBS)
    target_compile_definitions(qhotkey PRIVATE QHOTKEY_LIBRARY)
    target_compile_definitions(qhotkey PUBLIC QHOTKEY_SHARED)
endif()

if(APPLE)
    find_library(CARBON_LIBRARY Carbon)
    mark_as_advanced(CARBON_LIBRARY)

    target_sources(qhotkey PRIVATE QHotkey/qhotkey_mac.cpp)
    target_link_libraries(qhotkey PRIVATE ${CARBON_LIBRARY})
elseif(WIN32)
    target_sources(qhotkey PRIVATE QHotkey/qhotkey_win.cpp)
else()
    find_package(X11 REQUIRED)
    if(QT_DEFAULT_MAJOR_VERSION GREATER_EQUAL 6)
        target_link_libraries(qhotkey PRIVATE ${X11_LIBRARIES})
    else()
        find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS X11Extras REQUIRED)
        target_link_libraries(qhotkey
            PRIVATE
                ${X11_LIBRARIES}
                Qt${QT_DEFAULT_MAJOR_VERSION}::X11Extras)
    endif()

    include_directories(${X11_INCLUDE_DIR})
    target_sources(qhotkey PRIVATE QHotkey/qhotkey_x11.cpp)
endif()

include(GNUInstallDirs)

target_include_directories(qhotkey
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/QHotkey>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

include(CMakePackageConfigHelpers)

set_target_properties(qhotkey PROPERTIES
    SOVERSION ${PROJECT_VERSION_MAJOR}
    VERSION ${PROJECT_VERSION}
    INTERFACE_QHotkey_MAJOR_VERSION ${PROJECT_VERSION_MAJOR}
    COMPATIBLE_INTERFACE_STRING QHotkey_MAJOR_VERSION)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/QHotkeyConfigVersion.cmake
    VERSION "${PROJECT_VERSION}"
    COMPATIBILITY AnyNewerVersion)

if(QHOTKEY_EXAMPLES)
    add_subdirectory(HotkeyTest)
endif()

if(QHOTKEY_INSTALL)
    set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/QHotkey)

    install(
        TARGETS qhotkey EXPORT QHotkeyConfig
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/QHotkey/qhotkey.h
        ${CMAKE_CURRENT_SOURCE_DIR}/QHotkey/QHotkey
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/QHotkeyConfigVersion.cmake
        DESTINATION ${INSTALL_CONFIGDIR})
    install(EXPORT QHotkeyConfig DESTINATION ${INSTALL_CONFIGDIR})

    export(TARGETS qhotkey FILE QHotkeyConfig.cmake)
endif()

=== libraries/qlitehtml/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(
  qlitehtml
  VERSION 1.0
  LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(QLITEHTML_EXPORT qlitehtml)
set(QLITEHTML_DEVEL_COMPONENT Devel)
set(QLITEHTML_DEVEL_EXCLUDE_FROM_ALL NO)

if(UNIX OR MINGW)
  include(GNUInstallDirs)
  set(QLITEHTML_BIN_PATH ${CMAKE_INSTALL_BINDIR})
  set(QLITEHTML_LIBRARY_PATH ${CMAKE_INSTALL_LIBDIR})
  set(QLITEHTML_HEADER_PATH ${CMAKE_INSTALL_INCLUDEDIR}/qlitehtml)
else()
  set(QLITEHTML_BIN_PATH bin)
  set(QLITEHTML_LIBRARY_PATH lib)
  set(QLITEHTML_HEADER_PATH include/qlitehtml)
endif()

find_package(
  QT 5.11 NAMES Qt6 Qt5
  COMPONENTS Widgets
  REQUIRED)
find_package(
  Qt${QT_VERSION_MAJOR}
  COMPONENTS Widgets
  REQUIRED)
set(Qt Qt${QT_VERSION_MAJOR})

set(QLITEHTML_BUILD_TESTS OFF)
if(QLITEHTML_BUILD_TESTS)
  add_subdirectory(tests/manual/browser)
endif()

add_subdirectory(src)

=== libraries/qlitehtml/src/CMakeLists.txt ===
# set the following variables before adding as subdirectory into a project
# QLITEHTML_BIN_PATH - relative install path for result DLLs
# QLITEHTML_LIBRARY_PATH - relative install path for result dynamic libraries
# QLITEHTML_LIBRARY_ARCHIVE_PATH - relative install path for result archives
# (.lib, static lib), defaults to QLITEHTML_LIBRARY_PATH QLITEHTML_EXPORT -
# export name for qlitehtml QLITEHTML_DEVEL_COMPONENT - component name for
# development installation QLITEHTML_DEVEL_EXCLUDE_FROM_ALL - if development
# component should not be installed by default QLITEHTML_HEADER_PATH - relative
# install path for development headers QLITEHTML_LIBRARY_TYPE - SHARED or
# STATIC, defaults to SHARED
set(QLITEHTML_VERSION ${PROJECT_VERSION})
set(QLITEHTML_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(QLITEHTML_VERSION_COMPAT
    ${QLITEHTML_VERSION}
    CACHE STRING "qlitehtml compat version number.")

find_package(litehtml QUIET)
message("Trying to find " litehtml)
if(NOT TARGET litehtml
   AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/litehtml/CMakeLists.txt)
  set(ORIG_FPIC ${CMAKE_POSITION_INDEPENDENT_CODE})
  set(ORIG_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
  if(WIN32)
    set(LITEHTML_UTF8
        ON
        CACHE BOOL "")
  endif()
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  set(BUILD_SHARED_LIBS OFF)

  message("Adding 3rdparty/litehtml")
  add_subdirectory(3rdparty/litehtml EXCLUDE_FROM_ALL)

  set(CMAKE_POSITION_INDEPENDENT_CODE "${ORIG_FPIC}")
  set(BUILD_SHARED_LIBS ${ORIG_BUILD_SHARED_LIBS})
  # force optimized litehtml even in debug
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    # except for windows
    if(NOT WIN32)
      target_compile_options(gumbo PRIVATE -O2)
      target_compile_options(litehtml PRIVATE -O2)
    endif()
  endif()
endif()

# TODO error if litehtml was not found?

if(TARGET litehtml)
  set(PUBLIC_HEADERS
      element_checkbox.h element_checkbox.cpp container_qpainter.h
      container_qpainter_p.h qlitehtml_global.h qlitehtmlwidget.h)
  if(NOT QLITEHTML_LIBRARY_TYPE)
    set(QLITEHTML_LIBRARY_TYPE SHARED)
  endif()
  if(NOT QLITEHTML_LIBRARY_ARCHIVE_PATH)
    set(QLITEHTML_LIBRARY_ARCHIVE_PATH "${QLITEHTML_LIBRARY_PATH}")
  endif()

  add_library(qlitehtml ${QLITEHTML_LIBRARY_TYPE} ${PUBLIC_HEADERS}
                        container_qpainter.cpp qlitehtmlwidget.cpp)

  target_include_directories(
    qlitehtml PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
  target_link_libraries(
    qlitehtml
    PUBLIC Qt${QT_VERSION_MAJOR}::Widgets
    PRIVATE litehtml)
  target_compile_definitions(
    qlitehtml PRIVATE QT_NO_JAVA_STYLE_ITERATORS QT_NO_CAST_TO_ASCII
                      QT_RESTRICTED_CAST_FROM_ASCII QT_USE_QSTRINGBUILDER)
  if("${QLITEHTML_LIBRARY_TYPE}" STREQUAL "SHARED")
    target_compile_definitions(qlitehtml PRIVATE QLITEHTML_LIBRARY)
  else()
    target_compile_definitions(qlitehtml PUBLIC QLITEHTML_STATIC_LIBRARY)
  endif()
  if(WIN32)
    target_compile_definitions(qlitehtml PRIVATE UNICODE _UNICODE
                                                 _CRT_SECURE_NO_WARNINGS)
    if(NOT BUILD_WITH_PCH)
      # Windows 8 0x0602
      target_compile_definitions(
        qlitehtml PRIVATE WINVER=0x0602 _WIN32_WINNT=0x0602 WIN32_LEAN_AND_MEAN)
    endif()
  endif()

  set_target_properties(
    qlitehtml
    PROPERTIES SOURCES_DIR "${CMAKE_CURRENT_SOURCE_DIR}"
               VERSION "${QLITEHTML_VERSION}"
               SOVERSION "${QLITEHTML_VERSION_MAJOR}"
               MACHO_CURRENT_VERSION "${QLITEHTML_VERSION}"
               MACHO_COMPATIBILITY_VERSION "${QLITEHTML_VERSION_COMPAT}"
               CXX_EXTENSIONS OFF
               CXX_VISIBILITY_PRESET hidden
               VISIBILITY_INLINES_HIDDEN ON
               POSITION_INDEPENDENT_CODE ON)

  if(WIN32)
    set_target_properties(
      qlitehtml
      PROPERTIES
        SUFFIX
        "${QLITEHTML_VERSION_MAJOR}${CMAKE_${QLITEHTML_LIBRARY_TYPE}_LIBRARY_SUFFIX}"
        PREFIX ""
        IMPORT_SUFFIX "${QLITEHTML_VERSION_MAJOR}${CMAKE_IMPORT_LIBRARY_SUFFIX}"
        IMPORT_PREFIX "")
  endif()

  if(DEFINED QLITEHTML_BIN_PATH AND DEFINED QLITEHTML_LIBRARY_PATH)
    set(_EXPORT)
    if(DEFINED QLITEHTML_EXPORT)
      set(_EXPORT EXPORT ${QLITEHTML_EXPORT})
      add_library(${QLITEHTML_EXPORT}::qlitehtml ALIAS qlitehtml)
    endif()

    set(_DEVEL_COMPONENT)
    set(_NAMELINK)
    if(DEFINED QLITEHTML_DEVEL_COMPONENT)
      set(_EXCLUDE)
      if(QLITEHTML_DEVEL_EXCLUDE_FROM_ALL)
        set(_EXCLUDE EXCLUDE_FROM_ALL)
      endif()
      set(_DEVEL_COMPONENT COMPONENT ${QLITEHTML_DEVEL_COMPONENT} ${_EXCLUDE})
      set(_NAMELINK NAMELINK_SKIP)
      install(TARGETS qlitehtml LIBRARY DESTINATION "${QLITEHTML_LIBRARY_PATH}"
                                        NAMELINK_ONLY ${_DEVEL_COMPONENT})
      if(DEFINED QLITEHTML_HEADER_PATH)
        install(
          FILES ${PUBLIC_HEADERS}
          DESTINATION ${QLITEHTML_HEADER_PATH}
          ${_DEVEL_COMPONENT})
        target_include_directories(
          qlitehtml PUBLIC $<INSTALL_INTERFACE:${QLITEHTML_HEADER_PATH}>)
      endif()
    endif()

    install(
      TARGETS qlitehtml ${_EXPORT}
      RUNTIME DESTINATION "${QLITEHTML_BIN_PATH}" OPTIONAL
      LIBRARY DESTINATION "${QLITEHTML_LIBRARY_PATH}" ${_NAMELINK} OPTIONAL
      OBJECTS DESTINATION "${QLITEHTML_LIBRARY_PATH}" ${_DEVEL_COMPONENT}
                                                      OPTIONAL
      ARCHIVE DESTINATION "${QLITEHTML_LIBRARY_ARCHIVE_PATH}"
              ${_DEVEL_COMPONENT} OPTIONAL)
  endif()

endif()

=== libraries/qlitehtml/src/3rdparty/litehtml/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(litehtml LANGUAGES C CXX)
include(CTest)
enable_testing()

# Soname MAJOR is incremented when symbols are removed or changed in an
# incompatible way MINOR is incremented when new symbols are added
set(PROJECT_MAJOR 0)
set(PROJECT_MINOR 0)

option(EXTERNAL_GUMBO
       "Link against external gumbo instead of shipping a bundled copy" OFF)
if(WIN32)
  option(EXTERNAL_XXD "Use external xxd" OFF)
else()
  option(EXTERNAL_XXD "Use external xxd" ON)
endif()

if(NOT EXTERNAL_GUMBO)
  add_subdirectory(src/gumbo)
endif()

set(SOURCE_LITEHTML
    src/background.cpp
    src/box.cpp
    src/codepoint.cpp
    src/context.cpp
    src/css_length.cpp
    src/css_selector.cpp
    src/document.cpp
    src/el_anchor.cpp
    src/el_base.cpp
    src/el_before_after.cpp
    src/el_body.cpp
    src/el_break.cpp
    src/el_cdata.cpp
    src/el_comment.cpp
    src/el_div.cpp
    src/element.cpp
    src/el_font.cpp
    src/el_image.cpp
    src/el_link.cpp
    src/el_li.cpp
    src/el_para.cpp
    src/el_script.cpp
    src/el_space.cpp
    src/el_style.cpp
    src/el_table.cpp
    src/el_td.cpp
    src/el_text.cpp
    src/el_title.cpp
    src/el_tr.cpp
    src/html.cpp
    src/html_tag.cpp
    src/iterators.cpp
    src/media_query.cpp
    src/style.cpp
    src/stylesheet.cpp
    src/table.cpp
    src/tstring_view.cpp
    src/url.cpp
    src/url_path.cpp
    src/utf8_strings.cpp
    src/web_color.cpp
    src/num_cvt.cpp
    src/strtod.cpp)

set(HEADER_LITEHTML
    include/litehtml.h
    include/litehtml/attributes.h
    include/litehtml/background.h
    include/litehtml/borders.h
    include/litehtml/box.h
    include/litehtml/codepoint.h
    include/litehtml/context.h
    include/litehtml/css_length.h
    include/litehtml/css_margins.h
    include/litehtml/css_offsets.h
    include/litehtml/css_position.h
    include/litehtml/css_selector.h
    include/litehtml/document.h
    include/litehtml/el_anchor.h
    include/litehtml/el_base.h
    include/litehtml/el_before_after.h
    include/litehtml/el_body.h
    include/litehtml/el_break.h
    include/litehtml/el_cdata.h
    include/litehtml/el_comment.h
    include/litehtml/el_div.h
    include/litehtml/el_font.h
    include/litehtml/el_image.h
    include/litehtml/el_link.h
    include/litehtml/el_para.h
    include/litehtml/el_script.h
    include/litehtml/el_space.h
    include/litehtml/el_style.h
    include/litehtml/el_table.h
    include/litehtml/el_td.h
    include/litehtml/el_text.h
    include/litehtml/el_title.h
    include/litehtml/el_tr.h
    include/litehtml/element.h
    include/litehtml/html.h
    include/litehtml/html_tag.h
    include/litehtml/iterators.h
    include/litehtml/media_query.h
    include/litehtml/os_types.h
    include/litehtml/style.h
    include/litehtml/stylesheet.h
    include/litehtml/table.h
    include/litehtml/tstring_view.h
    include/litehtml/types.h
    include/litehtml/url.h
    include/litehtml/url_path.h
    include/litehtml/utf8_strings.h
    include/litehtml/web_color.h
    include/litehtml/num_cvt.h)

set(TEST_LITEHTML
    containers/test/container_test.cpp
    test/codepoint_test.cpp
    test/contextTest.cpp
    test/cssTest.cpp
    test/documentTest.cpp
    test/layoutGlobalTest.cpp
    test/mediaQueryTest.cpp
    test/tstring_view_test.cpp
    test/url_test.cpp
    test/url_path_test.cpp
    test/webColorTest.cpp)

set(PROJECT_LIB_VERSION ${PROJECT_MAJOR}.${PROJECT_MINOR}.0)
set(PROJECT_SO_VERSION ${PROJECT_MAJOR})

add_library(${PROJECT_NAME} ${SOURCE_LITEHTML})
set_target_properties(
  ${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_LIB_VERSION}
                             SOVERSION ${PROJECT_SO_VERSION})

set_target_properties(
  ${PROJECT_NAME}
  PROPERTIES CXX_STANDARD 11
             C_STANDARD 99
             PUBLIC_HEADER "${HEADER_LITEHTML}")

# Export litehtml includes.
target_include_directories(
  ${PROJECT_NAME}
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:include/${PROJECT_NAME}>)
target_include_directories(${PROJECT_NAME} PRIVATE include/${PROJECT_NAME})

option(LITEHTML_UTF8 "Build litehtml with UTF-8 text conversion functions." OFF)
if(LITEHTML_UTF8)
  target_compile_definitions(${PROJECT_NAME} PUBLIC LITEHTML_UTF8)
endif()

# Gumbo
target_link_libraries(${PROJECT_NAME} PUBLIC gumbo)

# install and export
install(
  TARGETS ${PROJECT_NAME}
  EXPORT litehtmlTargets
  RUNTIME DESTINATION bin COMPONENT libraries
  ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT libraries
  LIBRARY DESTINATION lib${LIB_SUFFIX} COMPONENT libraries
  PUBLIC_HEADER DESTINATION include/litehtml)
install(FILES cmake/litehtmlConfig.cmake
        DESTINATION lib${LIB_SUFFIX}/cmake/litehtml)
install(
  EXPORT litehtmlTargets
  FILE litehtmlTargets.cmake
  DESTINATION lib${LIB_SUFFIX}/cmake/litehtml)

# Binary Master.css
if(NOT EXTERNAL_XXD)
  add_executable(xxd xxd/xxd.c)
  set(XXD_COMMAND $<TARGET_FILE:xxd>)
else()
  find_program(XXD_COMMAND xxd)
endif()
if(WIN32)
  file(TO_NATIVE_PATH ${XXD_COMMAND} XXD_COMMAND)
  file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/include/master.css
       MASTER_FILE)
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc
    COMMAND type ${MASTER_FILE} | "${XXD_COMMAND}" -i >
            ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc)
else()
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc
    COMMAND cat ${CMAKE_CURRENT_SOURCE_DIR}/include/master.css | xxd -i >
            ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc)
endif()
set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc
                            PROPERTIES GENERATED TRUE)

# Tests

set(BUILD_TESTING OFF)
if(BUILD_TESTING)
  include(FetchContent)
  FetchContent_Declare(
    googletest
    URL https://github.com/google/googletest/archive/609281088cfefc76f9d0ce82e1ff6c30cc3591e5.zip
  )
  # For Windows: Prevent overriding the parent project's compiler/linker
  # settings
  set(gtest_force_shared_crt
      ON
      CACHE BOOL "" FORCE)
  FetchContent_GetProperties(googletest)
  if(NOT googletest_POPULATED)
    FetchContent_Populate(googletest)
    add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR})
  endif()

  enable_testing()

  set(TEST_NAME ${PROJECT_NAME}_tests)

  add_executable(${TEST_NAME} ${TEST_LITEHTML}
                              ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc)

  set_target_properties(
    ${TEST_NAME}
    PROPERTIES CXX_STANDARD 11
               C_STANDARD 99
               PUBLIC_HEADER "${HEADER_LITEHTML}")

  target_include_directories(${TEST_NAME}
                             PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/containers)

  target_link_libraries(${TEST_NAME} ${PROJECT_NAME} gtest_main)

  include(GoogleTest)
  gtest_discover_tests(${TEST_NAME})
endif()

# set(TEST_NAME ${PROJECT_NAME}_tests) add_executable(${TEST_NAME}
# ${TEST_LITEHTML} ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc)
# set_target_properties(${TEST_NAME} PROPERTIES CXX_STANDARD 11 C_STANDARD 99
# PUBLIC_HEADER "${HEADER_LITEHTML}" ) target_include_directories(${TEST_NAME}
# PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/containers)
# target_link_libraries(${TEST_NAME} PRIVATE ${PROJECT_NAME}) # tests
# add_test(NAME contextTest COMMAND ${TEST_NAME} 1) add_test(NAME cssTest
# COMMAND ${TEST_NAME} 2) add_test(NAME documentTest COMMAND ${TEST_NAME} 3)
# add_test(NAME layoutGlobalTest COMMAND ${TEST_NAME} 4) add_test(NAME
# mediaQueryTest COMMAND ${TEST_NAME} 5) add_test(NAME webColorTest COMMAND
# ${TEST_NAME} 6) endif()

=== libraries/qlitehtml/tests/manual/browser/CMakeLists.txt ===
find_package(
  ${Qt}
  COMPONENTS Widgets Network
  REQUIRED)

add_executable(qlitehtmlbrowser MACOSX_BUNDLE main.cpp)

target_include_directories(qlitehtmlbrowser PUBLIC ../../../src)
target_link_libraries(qlitehtmlbrowser qlitehtml ${Qt}::Widgets ${Qt}::Network)

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=qownnotes
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=25.10.4
pkgrel=1
pkgdesc="Plain-text file markdown note taking with Nextcloud/ownCloud integration"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qownnotes.org/'
msys2_repository_url='https://github.com/pbek/QOwnNotes/'
msys2_references=(
  'aur: qownnotes'
)
license=('spdx:GPL-2.0-or-later')
depends=(
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-qt6-svg"
  "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
  "${MINGW_PACKAGE_PREFIX}-openssl"
  "${MINGW_PACKAGE_PREFIX}-qt6-websockets"
  "${MINGW_PACKAGE_PREFIX}-aspell"
  "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
  "${MINGW_PACKAGE_PREFIX}-libgit2"
  "${MINGW_PACKAGE_PREFIX}-libbotan"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
source=("https://github.com/pbek/QOwnNotes/releases/download/v${pkgver}/qownnotes-${pkgver}.tar.xz"
        "0001-allow-system-botan.patch")
sha256sums=('b5a62b3eb8ab488bb5086b3c19e5f6961492f11d65de6afc60faa9907e18fdb9'
            'e332f9ad90713434224f3b1c4b344a9539dfe83acd62cd033490f9d4acf58633')

prepare() {
  cd "${_realname}-${pkgver}"

  patch -Np1 -i "${srcdir}/0001-allow-system-botan.patch"
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DQON_QT6_BUILD=ON \
      -DBUILD_WITH_SYSTEM_BOTAN=ON \
      -DBUILD_WITH_LIBGIT2=ON \
      -DBUILD_WITH_ASPELL=ON \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

=== debian/control ===
Source: qownnotes
Priority: optional
Maintainer: Patrizio Bekerle <patrizio@bekerle.com>
Section: editors
Build-Depends: debhelper (>= 9), cdbs, qt5-qmake, qtbase5-dev, libqt5svg5-dev, qtdeclarative5-dev, libqt5websockets5-dev, libqt5x11extras5-dev
Standards-Version: 3.9.6
Homepage: https://www.qownnotes.org
Vcs-Git: https://github.com/pbek/QOwnNotes.git
Vcs-Browser: https://github.com/pbek/QOwnNotes/

Package: qownnotes
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5core5a, libqt5gui5, libqt5sql5, libqt5sql5-sqlite, libqt5widgets5, libqt5qml5, libqt5svg5, libqt5network5, libqt5xml5, libqt5websockets5, libqt5x11extras5, openssl
Description: Plain-text file markdown note taking with Nextcloud/ownCloud integration
 Plain-text file markdown note taking with Nextcloud/ownCloud integration.
 You own your own notes! All notes are stored as plain-text files on your desktop computer.
 Sync them over devices (desktop & mobile) with ownCloud.
 Use Nextcloud Notes to edit your notes in the web.
